<script lang="ts">
  import { afterUpdate, createEventDispatcher } from "svelte";
  import type { SearchFilter } from "../module/store/Filters";

  const dispatch = createEventDispatcher();

  export let active: boolean = false;
  export let results: SearchFilter[] = [];
  export let selectedIndex: number = 0;

  let resultList: HTMLElement;

  afterUpdate(() => {
    resultList?.children[selectedIndex]?.scrollIntoView({ block: "nearest" });
  });

  function selected(index: number) {
    dispatch("selected", { index });
  }
</script>

{#if active}
  <ul class="quick-insert-result" bind:this={resultList}>
    {#each results as item, i (item.id)}
      <li class:search-selected={i === selectedIndex}>
        <!-- svelte-ignore a11y-missing-attribute -->
        <a on:click={() => selected(i)}>
          <span class="title">@{item.tag}</span>
          <span class="sub">{item.subTitle}</span>
        </a>
      </li>
    {/each}
  </ul>
{/if}
